/*====================================================================*/
/* Copyright (c) TNK  All Rights Reserved                             */
/* [̧ٖ] tiburn.c                                                  */
/* [T  v] tbVC^                                         */
/* [Q  ]                                                           */
/* [  ] 2006/12/12       ō쐬ҁFtanaka                       */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*====================================================================*/
/*--------------------------------------------------------------------*/
/*        ݸٰ                                                     */
/*--------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>

/*--------------------------------------------------------------------*/
/*        萔`                                                    */
/*--------------------------------------------------------------------*/
#define ASCIISIZE       256   /* Ǐo */
#define BLOCKSIZE       128    /* ݻ */
enum {
    TYPEUNKNOWN = -1,
    TYPEMOTOROLA1,
    TYPEMOTOROLA2,
    TYPESUM
};

#define _NEW(a)         HeapAlloc(GetProcessHeap(),HEAP_ZERO_MEMORY,a)
#define _DELETE(a)      HeapFree(GetProcessHeap(),0,(LPVOID)a)

typedef unsigned char  UBYTE;

/* ֐߂l */
#define ERRORNONE       0     /* I */
#define ERRORPARM       -1    /* Ұװ */
#define ERRORTOE        -2    /* Mѱ */
#define ERRORSEND       -3    /* Mװ */
#define ERRORRECV       -4    /* Mװ */
#define ERRORSUM        -5    /* Mѥװ */
#define ERROROVER       -6    /* Mޯ̧ */
#define ERRORNOMM       -7    /* ۹Ďs */


/*--------------------------------------------------------------------*/
/*        \̒`                                                  */
/*--------------------------------------------------------------------*/
typedef struct {              /* Эƹݏݹ */
    LPBYTE  lpSend;               /* Mް߲ */
    UINT    cbSend;               /* Mް */
    LPBYTE  lpRecv;               /* Mް߲ */
    UINT    cbRecv;               /* Mް *//* Msv̏ꍇ  */
    UINT    cbRead;               /* ۂ̎Mް */
    int     nResult;
} COMCELL,*PCOMCELL,FAR *LPCOMCELL;


/*--------------------------------------------------------------------*/
/*        O[o                                                  */
/*--------------------------------------------------------------------*/
char PortNum[32];


DCB dcb = {
    sizeof(DCB),
    CBR_115200,         // current baud rate
    TRUE,               // binary mode, no EOF check
    FALSE,              // enable parity checking
    FALSE,              // CTS output flow control
    FALSE,              // DSR output flow control
    DTR_CONTROL_DISABLE, // DTR flow control type
    FALSE,              // DSR sensitivity
    TRUE,               // XOFF continues Tx
    FALSE,              // XON/XOFF out flow control
    FALSE,              // XON/XOFF in flow control
    FALSE,              // enable error replacement
    FALSE,              // enable null stripping
    RTS_CONTROL_DISABLE, // RTS flow control +++ EnableȂ DSR Ȃ
    FALSE,              // abort on error
    0,                  // reserved
    0,                  // not currently used
    10,                 // transmit XON threshold
    10,                 // transmit XOFF threshold
    8,                  // number of bits/byte, 4-8
    NOPARITY,           // 0-4=no,odd,even,mark,space
    ONESTOPBIT,         // 0,1,2 = 1, 1.5, 2
    '\x11',             // Tx and Rx XON character
    '\x13',             // Tx and Rx XOFF character
    '\xFF',             // error replacement character
    '\xFF',             // end of input character
    0,                  // received event character
    0                   // reserved; do not use
};

COMMTIMEOUTS commtimeouts1 = {
    0,                  //ReadIntervalTimeout
    1,                  //ReadTotalTimeoutMultiplier
    200,                //ReadTotalTimeoutConstant
    1,                  //WriteTotalTimeoutMultiplier
    200                 //WriteTotalTimeoutConstant
};

HANDLE hComm = INVALID_HANDLE_VALUE;



/*--------------------------------------------------------------------*/
/* [֐] usage                                                     */
/* [  ] void usage(void)                                          */
/* [  ] none                                                      */
/* [o  ] none                                                      */
/* [T  v] gp@WG[ɏo͂                            */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
void usage(void) {
    static char  *msg[] = {
        "usage : tiburn [-pxxx] <infile>",
        "                  |        |",
        "                  |        +--- ϊHEX̧",
        "                  +------------ ߰ĥ߼",
        "",
        "  -p\\\\.\\COM? : COM߰Ďw(̫:COM1)",    // COM port (default:COM1)
        (char *)0
    };
    int  nloc;

    for(nloc = 0;msg[nloc] != (char *)0;nloc++) {
        fprintf(stderr,"%s\n",msg[nloc]);
    }
}
/*--------------------------------------------------------------------*/
/* [֐] E޲ؕϊ                                           */
/* [  ] int WINAPI ascii2nible(BYTE uch)                          */
/* [  ] uch:ϊ                                            */
/* [o  ] ޲                                                     */
/* [T  v] w肳ꂽ޲؂ɕϊ                       */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
int WINAPI ascii2nible(BYTE uch) {
    if((uch >= '0')&&(uch <= '9')) {
        return(uch - '0');
    }
    if((uch >= 'A')&&(uch <= 'F')) {
        return((uch - 'A') + 10);
    }
    if((uch >= 'a')&&(uch <= 'f')) {
        return((uch - 'a') + 10);
    }
    return(-1);
}
/*--------------------------------------------------------------------*/
/* [֐] E޲ؕϊ                                           */
/* [  ] int WINAPI smot2bin(                                      */
/*              LPBYTE lpbyte,LPBYTE lpascii,LPINT lptype)            */
/* [  ] lpbyte :ϊ敶߲                                 */
/*          lpascii:ϊ߲                               */
/*          lptype :                                        */
/* [o  ] ϊ                                                  */
/* [T  v] w肳ꂽ޲؂ɕϊ                       */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
int WINAPI smot2bin(LPBYTE lpbyte,LPBYTE lpascii,LPINT lptype) {
    int     nible;
    BYTE    ch;
    BYTE    bybuf;
    BYTE    bysum;
    int     nrtn;

    while((ch = *lpascii++) != 'S') {
        if(ch < ' ') {
            return(0);
        }
    }
    ch = *lpascii++ - '0';
    if(ch > 9) {
        return(-1);
    }
    *lpbyte++ = ch;
    for(bysum = 0,nrtn = 0;*lpascii >= ' ';nrtn++) {
        nible = ascii2nible(*lpascii++);
        if(nible < 0) {
            return(-1);
        }
        bybuf = (BYTE)(nible << 4);
        nible = ascii2nible(*lpascii++);
        if(nible < 0) {
            return(-1);
        }
        bybuf    |= (BYTE)nible;
        *lpbyte++ = bybuf;
        bysum    += bybuf;
    }
    if(*lptype == TYPEUNKNOWN) {
        if(bysum == 0xFF) {
            *lptype = TYPEMOTOROLA1;
        } else if(bysum == 0x00) {
            *lptype = TYPEMOTOROLA2;
        }
    } else {
        if(*lptype == TYPEMOTOROLA1) {
            if(bysum != 0xFF) {
                nrtn = -1;
            }
        } else if(*lptype == TYPEMOTOROLA2) {
            if(bysum != 0x00) {
                nrtn = -1;
            }
        } else {
            nrtn = -1;
        }
        if(nrtn < 0) {
            printf("тɈُ킪܂B\n");
        }
    }
    return(nrtn);
}
/*--------------------------------------------------------------------*/
/* [֐] MOŢٕϊ                                               */
/* [  ] DWORD WINAPI GetMotDat(                                   */
/*              FILE *ifp,LPBYTE lpImg,LPBYTE lpMap,int nShift,       */
/*              LPINT lptype)                                         */
/* [  ] ifp   :̧فE߲                                        */
/*          lpImg :ϊފi[߲                                */
/*          lpMap :ϊޗL\ۑ߲                        */
/*          nShift:ۯE                                        */
/*          lptype:                                         */
/* [o  ] ϊ                                                  */
/* [T  v] w肳ꂽ̧ق޲؂ɕϊۯ̗L/Ă */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
DWORD WINAPI GetMotDat(
FILE *ifp,
LPBYTE lpImg,
LPBYTE lpMap,
int nShift,
LPINT lptype) {
    BYTE   szBuf[ASCIISIZE];
    BYTE   byCnv[128];
    BYTE  *chp;
    int    type;
    int    ncnt;
    DWORD  addr;
    int    nlno;
    DWORD  addrhold = 0;

    for(nlno = 1;fgets(szBuf,sizeof(szBuf),ifp);nlno++) {
        if(szBuf[0] == '\0') {
            break;
        }
        ncnt = smot2bin(byCnv,szBuf,lptype);
        if((ncnt < 5)&&(ncnt != 0)) {
            sprintf(szBuf,"line[%d] record error.\n",nlno);
//            MessageBox(NULL,szBuf,gszAppName,MB_OK);
        } else {
            chp  = byCnv;
            type = *chp++;
            ncnt = *chp++;
            addr = 0;
            switch(type) {
                case 3:
                    addr |= (DWORD)*chp++ * 0x1000000;
                    ncnt -= 1;
                case 2:
                    addr  = (DWORD)*chp++ * 0x10000;
                    ncnt -= 1;
                case 1:
                    addr |= (DWORD)*chp++ * 0x100;
                    addr |= (DWORD)*chp++;
                    ncnt -= 2 + 1; //+sum
                    if(addrhold < (addr + ncnt - 1)) {
                        addrhold = (addr + ncnt - 1);
                    }
                    if(lpImg) {
                        CopyMemory(&lpImg[addr],chp,ncnt);
                        lpMap[addr >> nShift] = TRUE;
                        lpMap[(addr + ncnt - 1) >> nShift] = TRUE;
                    }
            }
        }
    }
    fseek(ifp,0L,SEEK_SET);
    return(addrhold);
}
/*--------------------------------------------------------------------*/
/* [֐] ̧٥ߎ擾                                             */
/* [  ] int WINAPI GetHexType(FILE *ifp,LPINT lpi)                */
/* [  ] ifp:̧٥߲                                            */
/*          lpi:sĥ߲                                        */
/* [o  ] 茋                                                  */
/* [T  v] w肳ꂽ̧ق߂擾                            */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
int WINAPI GetHexType(FILE *ifp,LPINT lpi) {
    CHAR  szBuf[ASCIISIZE];
    BYTE  byCnv[128];
    int   nrtc = TYPEUNKNOWN;

    for(*lpi = 0;fgets(szBuf,sizeof(szBuf),ifp);(*lpi)++) {
        if(szBuf[0] == 'S') {
            if(nrtc == TYPEUNKNOWN) {
                smot2bin(byCnv,szBuf,&nrtc);
            } else if((nrtc != TYPEMOTOROLA1)&&
                      (nrtc != TYPEMOTOROLA2)) {
                nrtc = TYPEUNKNOWN;
                break;
            }
        } else if(szBuf[0] == '\0') {       //I
            break;
        } else if(szBuf[0] != '\n') {
            nrtc = TYPEUNKNOWN;
            break;
        }
    }
    fseek(ifp,0L,SEEK_SET);
    return(nrtc);
}
/*--------------------------------------------------------------------*/
/* [֐] UARTM                                                  */
/* [  ] DWORD WINAPI SioSend(LPBYTE lpByte,DWORD cbByte)          */
/* [  ] lpByte:Mް]߲                                */
/*          cbByte:Mް                                         */
/* [o  ] ۑ                                              */
/* [T  v] UARTް𑗐M                                      */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
DWORD WINAPI SioSend(LPBYTE lpByte,DWORD cbByte) {
    DWORD  cbWrite;
#if 0
    DWORD  cb;

//ȂCP2303̏ꍇAŏPʂőȂƃf[^󂯎Ȃ
    for(cbWrite = 0;cbWrite < cbByte;cbWrite++) {
        WriteFile(hComm,&lpByte[cbWrite],1,&cb,NULL);
    }
#else
    WriteFile(hComm,(LPVOID)lpByte,cbByte,&cbWrite,NULL);
#endif
    return(cbWrite);
}
/*--------------------------------------------------------------------*/
/* [֐] UARTM                                                  */
/* [  ] DWORD WINAPI SioRecv(VOID)                                */
/* [  ] none                                                      */
/* [o  ] M                                                  */
/* [T  v] UARTްM                                    */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
DWORD WINAPI SioRecv(VOID) {
    BYTE   byt;
    DWORD  cbRead;
    int    nretry = 10;

#ifndef DEBUG
    for(cbRead = 0;(cbRead < sizeof(BYTE))&&(nretry);nretry--) {
#else
    for(cbRead = 0;(cbRead < sizeof(BYTE));) {
#endif
        ReadFile(hComm,(LPVOID)&byt,sizeof(BYTE),&cbRead,NULL);
    }
    return((cbRead)?  (DWORD)byt : -1);
}
/*--------------------------------------------------------------------*/
/* [֐] wM                                                */
/* [  ] VOID WINAPI ComRecv(LPCOMCELL lpcc)                       */
/* [  ] lpcc :COMۯ߲                                  */
/* [o  ] none                                                      */
/* [T  v] ߹ĥްM                                      */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
VOID WINAPI ComRecv(LPCOMCELL lpcc) {
    int   nStage;
    DWORD rtc;
    BYTE  rxd;
    BYTE  rxsum;
    BYTE  rxhi;

    for(nStage = 0;nStage != 99;) {
        rtc = SioRecv();
        if(rtc == -1) {
            lpcc->nResult = ERRORTOE;
            break;
        }

//printf("0x%02X,",rtc);

        rxd = (BYTE)rtc;
        switch(nStage) {
            case 0:                     /* ESCM҂ */
                if(rxd == '\033') {
                    nStage       = 1;
                    lpcc->cbRead = 0;
                    rxsum        = 0;
                } else {
                    nStage = 99;
                    lpcc->nResult = ERRORRECV;
                }
                break;
            case 1:                          /* HM҂ */
                if(((rxd >= '0')&&(rxd <= '9'))||
                   ((rxd >= 'A')&&(rxd <= 'F'))) {
                    nStage = 2;
                    rxhi   = ((rxd >= 'A')?  rxd - 0x37 : rxd - 0x30) << 4;
                } else if(rxd == '\r') {
                    nStage = 99;
                    lpcc->cbRead--;
                    if(rxsum != 0) {
                        lpcc->nResult = ERRORSUM;
                    } else {
                        lpcc->nResult = ERRORNONE;
                    }
                } else {
                    nStage = 99;
                    lpcc->nResult = ERRORRECV;
                }
                break;
            case 2:                          /* LM҂ */
                if(((rxd >= '0')&&(rxd <= '9'))||
                   ((rxd >= 'A')&&(rxd <= 'F'))) {
                    rxd -= ((rxd >= 'A')?  0x37 : 0x30);
                    rxsum += rxhi | rxd;
                    lpcc->lpRecv[lpcc->cbRead++] = rxhi | rxd;
                    if(lpcc->cbRead >= lpcc->cbRecv) {
                        nStage = 99;
                        lpcc->nResult = ERROROVER;
                    } else {
                        nStage = 1;
                    }
                } else {
                    nStage = 99;
                    lpcc->nResult = ERRORRECV;
                }
                break;
        }
    }
    if(lpcc->nResult != ERRORNONE) {
        do {
            rtc = SioRecv();
        } while((rtc != -1)&&(rtc != '\r'));
    }
}
/*--------------------------------------------------------------------*/
/* [֐] ޲إϊ                                            */
/* [  ] BYTE WINAPI Nible2Ascii(BYTE byt)                         */
/* [  ] byt:ϊf[^                                          */
/* [o  ]                                                  */
/* [T  v] ޲؂𱽷ɕϊ                                     */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
static BYTE WINAPI Nible2Ascii(BYTE byt) {
    return(byt + ((byt > 9)?  0x37 : 0x30));
}
/*--------------------------------------------------------------------*/
/* [֐] ްݸw                                            */
/* [  ] int WINAPI ComCell(LPCOMCELL lpcc,int retry)              */
/* [  ] lpcc :COMۯ߲                                  */
/*          retry:đ׸                                            */
/* [o  ] IO                                              */
/* [T  v] ް̑Ms                                        */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
int WINAPI ComCell(LPCOMCELL lpcc,int retry) {
    LPBYTE         lpb;
    UINT           uLoc;
    UINT           uLen;
    BYTE           bySum;
    BYTE           byt;
    LPSTR          lpStr;
    int            nrtc = ERRORNONE;

    do {
        if((!lpcc)||
           (!lpcc->lpSend)||
           (!lpcc->cbSend)) {
            lpStr = "ComCell ҰُłB";
            nrtc = ERRORPARM;                     /* Ұװ */
            break;
        }
        lpcc->cbRead = 0;
        if(!(lpb = (LPBYTE)HeapAlloc(GetProcessHeap(),HEAP_ZERO_MEMORY,
                                        ((lpcc->cbSend + 1) * 2) + 2))) {
            lpStr = "؂̱۹ĂɎs܂B";
            nrtc = ERRORNOMM;                     /* ۹Ďs */
            break;
        }

        lpb[0] = '\033';
        bySum  = 0;
        for(uLen = 1,uLoc = 0;uLoc < lpcc->cbSend;uLoc++,uLen += 2) {
            byt           = lpcc->lpSend[uLoc];
            bySum        += byt;
            lpb[uLen]     = Nible2Ascii((BYTE)(byt >> 4));
            lpb[uLen + 1] = Nible2Ascii((BYTE)(byt & 15));
        }
        bySum         = 0 - bySum;
        lpb[uLen]     = Nible2Ascii((BYTE)(bySum >> 4));
        lpb[uLen + 1] = Nible2Ascii((BYTE)(bySum & 15));
        lpb[uLen + 2] = '\r';
        SioSend(lpb,uLen + 3);
        HeapFree(GetProcessHeap(),0,lpb);
        ComRecv(lpcc);
        nrtc = lpcc->nResult;
        switch(nrtc) {
            case ERRORNONE:
                break;
            case ERRORTOE:
                lpStr = "Mѱĥװ܂B";
                break;
            case ERRORRECV:
                lpStr = "M׸װ܂B";
                break;
            case ERRORSUM:
                lpStr = "Mѥװ܂B";
                break;
            case ERROROVER:
                lpStr = "Mޯ̧ނ܂B";
                break;
            default:
                lpStr = "sȴװ܂B";
        }
    } while(0);
    if(nrtc != ERRORNONE) {
//        MessageBox(NULL,lpStr,gszAppName,MB_OK | MB_ICONINFORMATION);
        printf("%s\n",lpStr);
        if((--retry) != 0) {
            Sleep(10);
            ComCell(lpcc,retry);
        }
    }
    return(nrtc);
}
/*--------------------------------------------------------------------*/
/* [֐] ޯĥ޲ID擾                                       */
/* [  ] int tiGetDev(void)                                        */
/* [  ] none                                                      */
/* [o  ] IO                                              */
/* [T  v] ޯĂ޲ID擾                                */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
int tiGetDev(void) {
    COMCELL  cc;
    BYTE     bySend[8];
    BYTE     byResp[8];

    cc.lpSend = bySend;               /* Mް߲ */
    cc.lpRecv = byResp;               /* Mް߲ */
    cc.cbRecv = sizeof(byResp);       /* Mް *//* Msv̏ꍇ  */
    bySend[0] = 'I';
    cc.cbSend = 1;
    if(ComCell(&cc,1) == ERRORNONE) {
        if(byResp[1] == 0) {
            printf("DEVICE=0x%02X%02X\n",byResp[3],byResp[2]);
            return(0);
        }
        printf("Error <0x%02X>\n",byResp[1]);
    }
    return(-1);
}
/*--------------------------------------------------------------------*/
/* [֐] ׯ                                                 */
/* [  ] int tiErase(void)                                         */
/* [  ] none                                                      */
/* [o  ] IO                                              */
/* [T  v] ޯĂׯ؂Sď                           */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
int tiErase(void) {
    COMCELL  cc;
    BYTE     bySend[64+5];
    BYTE     byResp[128];

    printf("Erase start.\n");
    cc.lpSend = bySend;               /* Mް߲ */
    cc.lpRecv = byResp;               /* Mް߲ */
    cc.cbRecv = sizeof(byResp);       /* Mް *//* Msv̏ꍇ  */
    bySend[0] = 'E';
    cc.cbSend = 1;
    if(ComCell(&cc,1) == ERRORNONE) {
#if 0
        if(byResp[1] == 0) {
            bySend[0] = 'G';
            bySend[1] = 0xC0;
            bySend[2] = 0xFF;
            bySend[3] = 0x20;
            bySend[4] = 0x00;
            cc.cbSend = 5;
            ComCell(&cc,1);
            if(byResp[64] == byResp[65]) {
                return(0);
            }
            printf("\nError detected.");
        } else {
            printf("\nError <0x%02X>",byResp[1]);
        }
#else
        if(byResp[1] == 0) {
            bySend[0] = 'F';
            bySend[1] = 0x00;
            bySend[2] = 0x80;
            bySend[3] = 0x00;
            bySend[4] = 0x04;
            bySend[5] = 0x00;
            bySend[6] = 0x00;
            cc.cbSend = 7;
            ComCell(&cc,1);
            if(byResp[1] == 0) {
                return(0);
            }
        }
        printf("\nError <0x%02X>\n",byResp[1]);
        printf("\tCRC = 0x%04X : 0x%04X\n",
               ((int)byResp[3] << 8) | byResp[2],
               ((int)byResp[5] << 8) | byResp[4]);
#endif
    }
    return(-1);
}
/*--------------------------------------------------------------------*/
/* [֐] ׯײ                                                 */
/* [  ] int tiProgram(int adr,int size,LPBYTE lpcode)             */
/* [  ] adr   :ݱڽ                                      */
/*          size  :ݻ                                       */
/*          lpcode:ް]߲                            */
/* [o  ] 폑ݎO                                          */
/* [T  v] w肳ꂽڽް擾w肳ꂽڽɏ */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
int tiProgram(int adr,int size,LPBYTE lpcode) {
    COMCELL  cc;
    BYTE     bySend[BLOCKSIZE + 5];
    BYTE     byResp[128];

    cc.lpSend = bySend;               /* Mް߲ */
    cc.lpRecv = byResp;               /* Mް߲ */
    cc.cbRecv = sizeof(byResp);       /* Mް *//* Msv̏ꍇ  */
    bySend[0] = 'P';
    bySend[1] = (BYTE)(adr);
    bySend[2] = (BYTE)(adr >> 8);
    bySend[3] = (BYTE)(size >> 1);    /* ܰސ */
    bySend[4] = (BYTE)(size >> 9);
    memcpy(&bySend[5],lpcode,size);
    cc.cbSend = size + 5;
    if(ComCell(&cc,1) == ERRORNONE) {
#if 0
        if(byResp[1] == 0) {
            bySend[0] = 'G';
            cc.cbSend = 5;
            ComCell(&cc,1);
            if(!memcmp(&lpb[4],&byResp[2],cbb - 4)) {
                return(0);
            }
            printf("\nError detected.");
        } else {
            printf("\nError <0x%02X>",byResp[1]);
        }
#else
        if(byResp[1] == 0) {
            bySend[0] = 'F';
            ComCell(&cc,1);
            if(byResp[1] == 0) {
                return(0);
            }
        }
        printf("\nError <0x%02X>\n",byResp[1]);
        printf("\tCRC = 0x%04X : 0x%04X\n",
               ((int)byResp[3] << 8) | byResp[2],
               ((int)byResp[5] << 8) | byResp[4]);
#endif
    }
    return(-1);
}
/*--------------------------------------------------------------------*/
/* [֐] ޯĥؾ                                               */
/* [  ] int doReset(void)                                         */
/* [  ] none                                                      */
/* [o  ] ɾ                                                   */
/* [T  v] ޯĂؾĥĂJTAG䂩J                   */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
int doReset(void) {
    COMCELL  cc;
    BYTE     bySend[8];
    BYTE     byResp[8];

    cc.lpSend = bySend;               /* Mް߲ */
    cc.lpRecv = byResp;               /* Mް߲ */
    cc.cbRecv = sizeof(byResp);       /* Mް *//* Msv̏ꍇ  */
    bySend[0] = 'T';
    cc.cbSend = 1;
    if(ComCell(&cc,1) == ERRORNONE) {
        Sleep(500);
    }
    return(0);
}
/*--------------------------------------------------------------------*/
/* [֐] ׯײ                                                 */
/* [  ] BOOL WINAPI SendMot(FILE *ifp)                            */
/* [  ] ifp:̧٥߲                                            */
/* [o  ] ݌                                              */
/* [T  v] ̧قϊׯ֏                             */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
BOOL WINAPI SendMot(FILE *ifp) {
    DWORD    cb;       // size of file and count of bytes read 
    int      nType;
    LPBYTE   lpImg;
    LPBYTE   lpMap;
    int      nShift;
    int      nLoc;
    INT      nLine;
    BOOL     bRtc = FALSE;

    do {
        nType = GetHexType(ifp,&nLine);
        if(nType == TYPEUNKNOWN) {
            printf("w肳ꂽ̧ق۰S̫ϯĂł܂B\n");
            break;
        }
        do {
            cb    = GetMotDat(ifp,(LPBYTE)NULL,(LPBYTE)NULL,0,&nType);
            lpImg = _NEW(cb + BLOCKSIZE - 1);
            lpMap = _NEW((cb / BLOCKSIZE) + ((cb % BLOCKSIZE)?  1 : 0));
            if((!lpImg)||(!lpMap)) {
                printf("Ɨp؂mۂł܂B\n");
                break;
            }
            FillMemory(lpImg,cb + BLOCKSIZE - 1,0xFF);
            FillMemory(lpMap,(cb / BLOCKSIZE) + ((cb % BLOCKSIZE)?  1 : 0),0x00);
            for(nShift = 0,nLoc = 1;
                (nLoc < 0x10000)&&(BLOCKSIZE > (DWORD)nLoc);
                nLoc <<= 1,nShift++);
            GetMotDat(ifp,lpImg,lpMap,nShift,&nType);
            printf("write ");
            for(nLoc = 0;cb != 0;nLoc++) {
                cb -= (cb >= BLOCKSIZE)?  BLOCKSIZE : cb;
                if(lpMap[nLoc]) {
                    if(tiProgram(nLoc << nShift,BLOCKSIZE,&lpImg[nLoc << nShift])) {
                        break;
                    }
                    printf(".");
                }
            }
            if(cb) {
                printf(" ׯ؂݂̏Ɏs܂B");
            } else {
                printf(" done.");
            }
            printf("\n");
            bRtc = TRUE;
        } while(0);
        if(lpImg) {
            _DELETE(lpImg);
        }
        if(lpMap) {
            _DELETE(lpMap);
        }
    } while(0);

    return(bRtc);
}
/*--------------------------------------------------------------------*/
/* [֐] decoopt                                                   */
/* [  ] int decoopt(int argc,char **argv,FILE **lppifp)           */
/* [  ] argc   : argv̗L                                     */
/*          argv   : z߲                                  */
/*          lppifp : o̧٥̍\߲                     */
/* [o  ] ߼݉͌(=0:I!=0:ُI)                  */
/* [T  v] ޥײ݂Ƃēnꂽ߼݂͂                   */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
int decoopt(int argc,char **argv,FILE **lppifp) {
    static char   buf[256];
    int    nloc;
    char  *pin    = (char *)0;
    int    rtc    = 0;

    *lppifp   = (FILE *)0;  /* stdin; */
    for(nloc = 1;nloc < argc;nloc++) {
        if((argv[nloc][0] == '-')||
           (argv[nloc][0] == '/')) {
            switch(argv[nloc][1] & 0xDF) {
                case 'P':
                    if(PortNum[0]) {
                        rtc = -1;
                        fprintf(stderr,"߰Ėdw肳Ă܂B\n");
                    } else {
                        strcpy(PortNum,&argv[nloc][2]);
                    }
                    break;
                default:
                    rtc = -1;
                    fprintf(stderr,"`ĂȂ߼݂ݒ肳Ă܂B\n");
            }
        } else if(pin != (char *)0) {
            rtc = -1;
            fprintf(stderr,"̧قdw肳Ă܂B\n");
        } else {
            pin = argv[nloc];
        }
    }
    if(pin == (char *)0) {
        rtc = -1;
        fprintf(stderr,"̧ق̎w肪܂B\n");
    } else if(rtc != -1) {
        *lppifp = fopen(pin,"rt");
        if(*lppifp == (FILE *)0) {
            rtc = -1;
            fprintf(stderr,"̧[%s]݂ł܂B\n",pin);
        }
    }
    if(rtc != -1) {
        if(!PortNum[0]) {
            strcpy(PortNum,"COM1");
        }
    }
    return(rtc);
}
/*--------------------------------------------------------------------*/
/* [֐] main                                                      */
/* [  ] int main(int argc,char **argv)                            */
/* [  ] argc   : argv̗L                                     */
/*          argv   : z߲                                  */
/* [o  ]                                                        */
/* [T  v] Ҳ݊֐                                                   */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
int main(int argc,char **argv) {
    FILE   *ifp;

    PortNum[0] = '\0';
    do {
        /* ُ͈̐ */
        if(argc <= 1) {
            usage();
            break;
        }
        if(decoopt(argc,argv,&ifp) != 0) {
            break;
        }
        hComm = CreateFile(PortNum,
                           GENERIC_READ | GENERIC_WRITE,
                           0,
                           NULL,
                           OPEN_EXISTING,
                           FILE_ATTRIBUTE_NORMAL,
                           NULL);
        if(hComm == INVALID_HANDLE_VALUE) {
            fprintf(stderr, "%s could not be opened.\n", PortNum);
        } else {
            SetCommState(hComm, &dcb);
            SetCommTimeouts(hComm, &commtimeouts1);
            if((!tiGetDev())&&
               (!tiErase())) {
                SendMot(ifp);
                doReset();
            }
        }
        fclose(ifp);
    } while(0);
    return(0);
}
