/*====================================================================*/
/* Copyright (c) TNK  All Rights Reserved                             */
/* [̧ٖ] tiburn.c                                                  */
/* [T  v] tbVC^                                         */
/* [Q  ]                                                           */
/* [  ] 2006/12/12       ō쐬ҁFtanaka                       */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*====================================================================*/
/*--------------------------------------------------------------------*/
/*        ݸٰ                                                     */
/*--------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>
/*--------------------------------------------------------------------*/
/*        萔`                                                    */
/*--------------------------------------------------------------------*/
enum {
    IDHEX_UNKNOWN = -1,
    IDHEX_INTEL,
    IDHEX_MOTOLORA,
    IDHEX_SUM
};

typedef unsigned char  UBYTE;

/* ֐߂l */
#define ERRORNONE       0     /* I */
#define ERRORPARM       -1    /* Ұװ */
#define ERRORTOE        -2    /* Mѱ */
#define ERRORSEND       -3    /* Mװ */
#define ERRORRECV       -4    /* Mװ */
#define ERRORSUM        -5    /* Mѥװ */
#define ERROROVER       -6    /* Mޯ̧ */
#define ERRORNOMM       -7    /* ۹Ďs */

/*--------------------------------------------------------------------*/
/*        \̒`                                                  */
/*--------------------------------------------------------------------*/
typedef struct {              /* Эƹݏݹ */
    LPBYTE  lpSend;               /* Mް߲ */
    UINT    cbSend;               /* Mް */
    LPBYTE  lpRecv;               /* Mް߲ */
    UINT    cbRecv;               /* Mް *//* Msv̏ꍇ  */
    UINT    cbRead;               /* ۂ̎Mް */
    int     nResult;
} COMCELL,*PCOMCELL,FAR *LPCOMCELL;


/*--------------------------------------------------------------------*/
/*        O[o                                                  */
/*--------------------------------------------------------------------*/
char PortNum[32];


DCB dcb = {
    sizeof(DCB),
    CBR_115200,         // current baud rate
    TRUE,               // binary mode, no EOF check
    FALSE,              // enable parity checking
    FALSE,              // CTS output flow control
    FALSE,              // DSR output flow control
    DTR_CONTROL_DISABLE, // DTR flow control type
    FALSE,              // DSR sensitivity
    TRUE,               // XOFF continues Tx
    FALSE,              // XON/XOFF out flow control
    FALSE,              // XON/XOFF in flow control
    FALSE,              // enable error replacement
    FALSE,              // enable null stripping
    RTS_CONTROL_DISABLE, // RTS flow control +++ EnableȂ DSR Ȃ
    FALSE,              // abort on error
    0,                  // reserved
    0,                  // not currently used
    10,                 // transmit XON threshold
    10,                 // transmit XOFF threshold
    8,                  // number of bits/byte, 4-8
    NOPARITY,           // 0-4=no,odd,even,mark,space
    ONESTOPBIT,         // 0,1,2 = 1, 1.5, 2
    '\x11',             // Tx and Rx XON character
    '\x13',             // Tx and Rx XOFF character
    '\xFF',             // error replacement character
    '\xFF',             // end of input character
    0,                  // received event character
    0                   // reserved; do not use
};

COMMTIMEOUTS commtimeouts1 = {
    0,                  //ReadIntervalTimeout
    1,                  //ReadTotalTimeoutMultiplier
    200,                //ReadTotalTimeoutConstant
    1,                  //WriteTotalTimeoutMultiplier
    200                 //WriteTotalTimeoutConstant
};

HANDLE hComm = INVALID_HANDLE_VALUE;




/*--------------------------------------------------------------------*/
/* [֐] usage                                                     */
/* [  ] void usage(void)                                          */
/* [  ] none                                                      */
/* [o  ] none                                                      */
/* [T  v] gp@WG[ɏo͂                            */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
void usage(void) {
    static char  *msg[] = {
        "usage : tiburn [-pxxx] <infile>",
        "                  |        |",
        "                  |        +--- ϊHEX̧",
        "                  +------------ ߰ĥ߼",
        "",
        "  -p\\\\.\\COM? : COM߰Ďw(̫:COM1)",    // COM port (default:COM1)
        (char *)0
    };
    int  nloc;

    for(nloc = 0;msg[nloc] != (char *)0;nloc++) {
        fprintf(stderr,"%s\n",msg[nloc]);
    }
}
/*--------------------------------------------------------------------*/
/* [֐] Ascii2Nible                                               */
/* [  ] DWORD Ascii2Nible(char ch)                                */
/* [  ] ch : ϊ                                             */
/* [o  ] 32ޯĕϊް                                            */
/* [T  v] ASCIIޕPUiƂϊ                         */
/* [Q  ]                                                           */
/* [  ] PUiȊO O Ԃ                                    */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
DWORD Ascii2Nible(char ch) {
    if((ch >= '0')&&(ch <= '9')) {
        return(ch - '0');
    }
    if((ch >= 'A')&&(ch <= 'F')) {
        return(ch - 'A' + 10);
    }
    return(0);
}
/*--------------------------------------------------------------------*/
/* [֐] Ascii2Byte                                                */
/* [  ] DWORD Ascii2Byte(char *lpStr)                             */
/* [  ] lpStr : ϊ߲                                   */
/* [o  ] 32ޯĕϊް                                            */
/* [T  v] ASCIIޕ޲ĒPUiƂĕϊ               */
/* [Q  ]                                                           */
/* [  ] PUiȊOۏ؊O                                          */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
DWORD Ascii2Byte(char *lpStr) {
    return((Ascii2Nible(lpStr[0]) << 4) | Ascii2Nible(lpStr[1]));
}
/*--------------------------------------------------------------------*/
/* [֐] Ascii2Word                                                */
/* [  ] DWORD Ascii2Word(char *lpStr)                             */
/* [  ] lpStr : ϊ߲                                   */
/* [o  ] 32ޯĕϊް                                            */
/* [T  v] ASCIIޕܰޒPUiƂĕϊ               */
/* [Q  ]                                                           */
/* [  ] PUiȊOۏ؊O                                          */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
DWORD Ascii2Word(char *lpStr) {
    return((Ascii2Nible(lpStr[0]) << 12) |
           (Ascii2Nible(lpStr[1]) << 8) |
           (Ascii2Nible(lpStr[2]) << 4) |
            Ascii2Nible(lpStr[3]));
}
/*--------------------------------------------------------------------*/
/* [֐] AsciiTo24                                                 */
/* [  ] DWORD AsciiTo24(char *lpStr)                              */
/* [  ] lpStr : ϊ߲                                   */
/* [o  ] 32ޯĕϊް                                            */
/* [T  v] ASCIIޕ24ޯĒPUiƂĕϊ             */
/* [Q  ]                                                           */
/* [  ] PUiȊOۏ؊O                                          */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
DWORD AsciiTo24(char *lpStr) {
    return((Ascii2Nible(lpStr[0]) << 20) |
           (Ascii2Nible(lpStr[1]) << 16) |
           (Ascii2Nible(lpStr[2]) << 12) |
           (Ascii2Nible(lpStr[3]) << 8) |
           (Ascii2Nible(lpStr[4]) << 4) |
            Ascii2Nible(lpStr[5]));
}
/*--------------------------------------------------------------------*/
/* [֐] Ascii2Long                                                */
/* [  ] DWORD Ascii2Long(char *lpStr)                             */
/* [  ] lpStr : ϊ߲                                   */
/* [o  ] 32ޯĕϊް                                            */
/* [T  v] ASCIIޕݸޒPUiƂĕϊ               */
/* [Q  ]                                                           */
/* [  ] PUiȊOۏ؊O                                          */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
DWORD Ascii2Long(char *lpStr) {
    return((Ascii2Nible(lpStr[0]) << 28) |
           (Ascii2Nible(lpStr[1]) << 24) |
           (Ascii2Nible(lpStr[2]) << 20) |
           (Ascii2Nible(lpStr[3]) << 16) |
           (Ascii2Nible(lpStr[4]) << 12) |
           (Ascii2Nible(lpStr[5]) << 8) |
           (Ascii2Nible(lpStr[6]) << 4) |
            Ascii2Nible(lpStr[7]));
}
/*--------------------------------------------------------------------*/
/* [֐] gethextype                                                */
/* [  ] int gethextype(FILE *fp)                                  */
/* [  ] fp : ̧٥߲                                           */
/* [o  ] ͷُ̧                                              */
/* [T  v] w肳ꂽ̧ق߂擾B                          */
/* [Q  ]                                                           */
/* [  ] PUiȊOۏ؊O                                          */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
int gethextype(FILE *fp) {
    char  buf[256];
    int   nid = IDHEX_UNKNOWN;

    fseek(fp,0L,SEEK_SET);
    if(fgets(buf,sizeof(buf),fp) != (char *)0) {
        if(buf[0] == ':') {
            nid = IDHEX_INTEL;
        } else if(buf[0] == 'S') {
            nid = IDHEX_MOTOLORA;
        }
    }
    fseek(fp,0L,SEEK_SET);
    return(nid);
}
/*--------------------------------------------------------------------*/
/* [֐] GetROMImage                                               */
/* [  ] void GetROMImage(int type,BYTE *lpMem,FILE *ifp)          */
/* [  ] type  : ̧ق̎                                        */
/*          lpMem : ϊʊi[߲                                 */
/*          ifp   : ̧٥߲                                        */
/* [o  ] ϊꐔ                                                  */
/* [T  v] ROM̲Ұ(@B꺰)擾                          */
/* [Q  ]                                                           */
/* [  ] IntelHex|MotoloraHex̂ݑΉ                              */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
int GetROMImage(int type,BYTE *lpMem,FILE *ifp) {
    char   szBuf[256];
    BYTE   len;
    BYTE   loc;
    int    off;
    int    rtc = -2;  //skip

    if(!fgets(szBuf,sizeof(szBuf),ifp)) {  //EOF
        return(-1);
    }
    if(type == IDHEX_INTEL) {
        if(szBuf[0] == ':') {
            if((szBuf[1] == '0')&&
               (szBuf[2] == '2')&&
               (szBuf[7] == '0')&&
               ((szBuf[8] == '2')||
                (szBuf[8] == '4'))) {
                ;                                 //nothing(segment)
            } else if((szBuf[1] == '0')&&
                      (szBuf[2] == '0')&&
                      (szBuf[7] == '0')&&
                      (szBuf[8] == '1')) {
                ;                                 //nothing
            } else if((szBuf[7] == '0')&&
                      (szBuf[8] == '0')) {
                *(WORD *)&lpMem[0] = (WORD)Ascii2Word(&szBuf[3]);
                len                = (BYTE)Ascii2Byte(&szBuf[1]);
                *(WORD *)&lpMem[2] = (WORD)(len >> 1);            //ܰސɕϊ
                for(loc = 0;loc < len;loc++) {
                    lpMem[4 + loc] = (BYTE)Ascii2Byte(&szBuf[9 + loc * 2]);
                }
                rtc = len + 4;
            }
        }
    } else {
        if(szBuf[0] == 'S') {
            switch(szBuf[1]) {
                case '1':
                    *(WORD *)&lpMem[0] = (WORD)Ascii2Word(&szBuf[4]);
                    len                = (BYTE)Ascii2Byte(&szBuf[2]) - 3;
                    off                = 8;
                    break;
                case '2':
                    *(WORD *)&lpMem[0] = (WORD)AsciiTo24(&szBuf[4]);
                    len                = (BYTE)Ascii2Byte(&szBuf[2]) - 4;
                    off                = 10;
                    break;
                case '3':
                    *(WORD *)&lpMem[0] = (WORD)Ascii2Long(&szBuf[4]);
                    len                = (BYTE)Ascii2Byte(&szBuf[2]) - 5;
                    off                = 12;
                    break;
                default:
                    len                = 0;
            }
            if(len) {
                *(WORD *)&lpMem[2] = len >> 1;  //ܰސɕϊ
                for(loc = 0;loc < len;loc++) {
                    lpMem[4 + loc] = (BYTE)Ascii2Byte(&szBuf[off + loc * 2]);
                }
                rtc = len + 4;
            }
        }
    }
    return(rtc);
}
/*--------------------------------------------------------------------*/
/* [֐] UARTM                                                  */
/* [  ] DWORD WINAPI SioSend(LPBYTE lpByte,DWORD cbByte)          */
/* [  ] lpByte:Mް]߲                                */
/*          cbByte:Mް                                         */
/* [o  ] ۑ                                              */
/* [T  v] UARTް𑗐M                                      */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
DWORD WINAPI SioSend(LPBYTE lpByte,DWORD cbByte) {
    DWORD  cbWrite;
#if 0
    DWORD  cb;

//ȂCP2303̏ꍇAŏPʂőȂƃf[^󂯎Ȃ
    for(cbWrite = 0;cbWrite < cbByte;cbWrite++) {
        WriteFile(hComm,&lpByte[cbWrite],1,&cb,NULL);
    }
#else
    WriteFile(hComm,(LPVOID)lpByte,cbByte,&cbWrite,NULL);
#endif
    return(cbWrite);
}
/*--------------------------------------------------------------------*/
/* [֐] UARTM                                                  */
/* [  ] DWORD WINAPI SioRecv(VOID)                                */
/* [  ] none                                                      */
/* [o  ] M                                                  */
/* [T  v] UARTްM                                    */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
DWORD WINAPI SioRecv(VOID) {
    BYTE   byt;
    DWORD  cbRead;
    int    nretry = 10;

#ifndef DEBUG
    for(cbRead = 0;(cbRead < sizeof(BYTE))&&(nretry);nretry--) {
#else
    for(cbRead = 0;(cbRead < sizeof(BYTE));) {
#endif
        ReadFile(hComm,(LPVOID)&byt,sizeof(BYTE),&cbRead,NULL);
    }
    return((cbRead)?  (DWORD)byt : -1);
}

/*--------------------------------------------------------------------
  _SioPutc
  --------------------------------------------------------------------*/
DWORD WINAPI SioPutc(BYTE snd) {
    return(SioSend(&snd,sizeof(BYTE)));
}

/*--------------------------------------------------------------------
  
  --------------------------------------------------------------------*/
VOID WINAPI SioWait(VOID) {
    DWORD  dwEvtMask;

    WaitCommEvent(hComm,&dwEvtMask,NULL);
}

/*--------------------------------------------------------------------*/
/* [֐] wM                                                */
/* [  ] VOID WINAPI ComRecv(LPCOMCELL lpcc)                       */
/* [  ] lpcc :COMۯ߲                                  */
/* [o  ] none                                                      */
/* [T  v] ߹ĥްM                                      */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
VOID WINAPI ComRecv(LPCOMCELL lpcc) {
    int   nStage;
    DWORD rtc;
    BYTE  rxd;
    BYTE  rxsum;
    BYTE  rxhi;

    for(nStage = 0;nStage != 99;) {
        rtc = SioRecv();
        if(rtc == -1) {
            lpcc->nResult = ERRORTOE;
            break;
        }

//printf("0x%02X,",rtc);

        rxd = (BYTE)rtc;
        switch(nStage) {
            case 0:                     /* ESCM҂ */
                if(rxd == '\033') {
                    nStage       = 1;
                    lpcc->cbRead = 0;
                    rxsum        = 0;
                } else {
                    nStage = 99;
                    lpcc->nResult = ERRORRECV;
                }
                break;
            case 1:                          /* HM҂ */
                if(((rxd >= '0')&&(rxd <= '9'))||
                   ((rxd >= 'A')&&(rxd <= 'F'))) {
                    nStage = 2;
                    rxhi   = ((rxd >= 'A')?  rxd - 0x37 : rxd - 0x30) << 4;
                } else if(rxd == '\r') {
                    nStage = 99;
                    lpcc->cbRead--;
                    if(rxsum != 0) {
                        lpcc->nResult = ERRORSUM;
                    } else {
                        lpcc->nResult = ERRORNONE;
                    }
                } else {
                    nStage = 99;
                    lpcc->nResult = ERRORRECV;
                }
                break;
            case 2:                          /* LM҂ */
                if(((rxd >= '0')&&(rxd <= '9'))||
                   ((rxd >= 'A')&&(rxd <= 'F'))) {
                    rxd -= ((rxd >= 'A')?  0x37 : 0x30);
                    rxsum += rxhi | rxd;
                    lpcc->lpRecv[lpcc->cbRead++] = rxhi | rxd;
                    if(lpcc->cbRead >= lpcc->cbRecv) {
                        nStage = 99;
                        lpcc->nResult = ERROROVER;
                    } else {
                        nStage = 1;
                    }
                } else {
                    nStage = 99;
                    lpcc->nResult = ERRORRECV;
                }
                break;
        }
    }
    if(lpcc->nResult != ERRORNONE) {
        do {
            rtc = SioRecv();
        } while((rtc != -1)&&(rtc != '\r'));
    }
}
/*--------------------------------------------------------------------*/
/* [֐] ޲إϊ                                            */
/* [  ] BYTE WINAPI Nible2Ascii(BYTE byt)                         */
/* [  ] byt:ϊf[^                                          */
/* [o  ]                                                  */
/* [T  v] ޲؂𱽷ɕϊ                                     */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
static BYTE WINAPI Nible2Ascii(BYTE byt) {
    return(byt + ((byt > 9)?  0x37 : 0x30));
}
/*--------------------------------------------------------------------*/
/* [֐] ްݸw                                            */
/* [  ] int WINAPI ComCell(LPCOMCELL lpcc,int retry)              */
/* [  ] lpcc :COMۯ߲                                  */
/*          retry:đ׸                                            */
/* [o  ] IO                                              */
/* [T  v] ް̑Ms                                        */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
int WINAPI ComCell(LPCOMCELL lpcc,int retry) {
    LPBYTE         lpb;
    UINT           uLoc;
    UINT           uLen;
    BYTE           bySum;
    BYTE           byt;
    LPSTR          lpStr;
    int            nrtc = ERRORNONE;

    do {
        if((!lpcc)||
           (!lpcc->lpSend)||
           (!lpcc->cbSend)) {
            lpStr = "ComCell ҰُłB";
            nrtc = ERRORPARM;                     /* Ұװ */
            break;
        }
        lpcc->cbRead = 0;
        if(!(lpb = (LPBYTE)HeapAlloc(GetProcessHeap(),HEAP_ZERO_MEMORY,
                                        ((lpcc->cbSend + 1) * 2) + 2))) {
            lpStr = "؂̱۹ĂɎs܂B";
            nrtc = ERRORNOMM;                     /* ۹Ďs */
            break;
        }

        lpb[0] = '\033';
        bySum  = 0;
        for(uLen = 1,uLoc = 0;uLoc < lpcc->cbSend;uLoc++,uLen += 2) {
            byt           = lpcc->lpSend[uLoc];
            bySum        += byt;
            lpb[uLen]     = Nible2Ascii((BYTE)(byt >> 4));
            lpb[uLen + 1] = Nible2Ascii((BYTE)(byt & 15));
        }
        bySum         = 0 - bySum;
        lpb[uLen]     = Nible2Ascii((BYTE)(bySum >> 4));
        lpb[uLen + 1] = Nible2Ascii((BYTE)(bySum & 15));
        lpb[uLen + 2] = '\r';
        SioSend(lpb,uLen + 3);
        HeapFree(GetProcessHeap(),0,lpb);
        ComRecv(lpcc);
        nrtc = lpcc->nResult;
        switch(nrtc) {
            case ERRORNONE:
                break;
            case ERRORTOE:
                lpStr = "Mѱĥװ܂B";
                break;
            case ERRORRECV:
                lpStr = "M׸װ܂B";
                break;
            case ERRORSUM:
                lpStr = "Mѥװ܂B";
                break;
            case ERROROVER:
                lpStr = "Mޯ̧ނ܂B";
                break;
            default:
                lpStr = "sȴװ܂B";
        }
    } while(0);
    if(nrtc != ERRORNONE) {
//        MessageBox(NULL,lpStr,gszAppName,MB_OK | MB_ICONINFORMATION);
        printf("%s\n",lpStr);
        if((--retry) != 0) {
            Sleep(10);
            ComCell(lpcc,retry);
        }
    }
    return(nrtc);
}
/*--------------------------------------------------------------------*/
/* [֐] ޯĥ޲ID擾                                       */
/* [  ] int tiGetDev(void)                                        */
/* [  ] none                                                      */
/* [o  ] IO                                              */
/* [T  v] ޯĂ޲ID擾                                */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
int tiGetDev(void) {
    COMCELL  cc;
    BYTE     bySend[8];
    BYTE     byResp[8];

    cc.lpSend = bySend;               /* Mް߲ */
    cc.lpRecv = byResp;               /* Mް߲ */
    cc.cbRecv = sizeof(byResp);       /* Mް *//* Msv̏ꍇ  */
    bySend[0] = 'I';
    cc.cbSend = 1;
    if(ComCell(&cc,1) == ERRORNONE) {
        if(byResp[1] == 0) {
            printf("DEVICE=0x%02X%02X\n",byResp[3],byResp[2]);
            return(0);
        }
        printf("Error <0x%02X>\n",byResp[1]);
    }
    return(-1);
}
/*--------------------------------------------------------------------*/
/* [֐] ׯ                                                 */
/* [  ] int tiErase(void)                                         */
/* [  ] none                                                      */
/* [o  ] IO                                              */
/* [T  v] ޯĂׯ؂Sď                           */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
int tiErase(void) {
    COMCELL  cc;
    BYTE     bySend[64+5];
    BYTE     byResp[128];

    printf("Erase start.\n");
    cc.lpSend = bySend;               /* Mް߲ */
    cc.lpRecv = byResp;               /* Mް߲ */
    cc.cbRecv = sizeof(byResp);       /* Mް *//* Msv̏ꍇ  */
    bySend[0] = 'E';
    cc.cbSend = 1;
    if(ComCell(&cc,1) == ERRORNONE) {
#if 0
        if(byResp[1] == 0) {
            bySend[0] = 'G';
            bySend[1] = 0xC0;
            bySend[2] = 0xFF;
            bySend[3] = 0x20;
            bySend[4] = 0x00;
            cc.cbSend = 5;
            ComCell(&cc,1);
            if(byResp[64] == byResp[65]) {
                return(0);
            }
            printf("\nError detected.");
        } else {
            printf("\nError <0x%02X>",byResp[1]);
        }
#else
        if(byResp[1] == 0) {
            bySend[0] = 'F';
            bySend[1] = 0x00;
            bySend[2] = 0x80;
            bySend[3] = 0x00;
            bySend[4] = 0x04;
            bySend[5] = 0x00;
            bySend[6] = 0x00;
            cc.cbSend = 7;
            ComCell(&cc,1);
            if(byResp[1] == 0) {
                return(0);
            }
        }
        printf("\nError <0x%02X>\n",byResp[1]);
        printf("\tCRC = 0x%04X : 0x%04X\n",
               ((int)byResp[3] << 8) | byResp[2],
               ((int)byResp[5] << 8) | byResp[4]);
#endif
    }
    return(-1);
}
/*--------------------------------------------------------------------*/
/* [֐] ׯײ                                                 */
/* [  ] int tiProgram(int adr,int size,LPBYTE lpcode)             */
/* [  ] adr   :ݱڽ                                      */
/*          size  :ݻ                                       */
/*          lpcode:ް]߲                            */
/* [o  ] 폑ݎO                                          */
/* [T  v] w肳ꂽڽް擾w肳ꂽڽɏ */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
int tiProgram(BYTE *lpb,DWORD cbb) {
    COMCELL  cc;
    BYTE     bySend[64 + 5];
    BYTE     byResp[128];

    cc.lpSend = bySend;               /* Mް߲ */
    cc.lpRecv = byResp;               /* Mް߲ */
    cc.cbRecv = sizeof(byResp);       /* Mް *//* Msv̏ꍇ  */
    bySend[0] = 'P';
    memcpy(&bySend[1],lpb,cbb);
    cc.cbSend = cbb + 1;
    if(ComCell(&cc,1) == ERRORNONE) {
#if 0
        if(byResp[1] == 0) {
            bySend[0] = 'G';
            cc.cbSend = 5;
            ComCell(&cc,1);
            if(!memcmp(&lpb[4],&byResp[2],cbb - 4)) {
                return(0);
            }
            printf("\nError detected.");
        } else {
            printf("\nError <0x%02X>",byResp[1]);
        }
#else
        if(byResp[1] == 0) {
            bySend[0] = 'F';
            ComCell(&cc,1);
            if(byResp[1] == 0) {
                return(0);
            }
        }
        printf("\nError <0x%02X>\n",byResp[1]);
        printf("\tCRC = 0x%04X : 0x%04X\n",
               ((int)byResp[3] << 8) | byResp[2],
               ((int)byResp[5] << 8) | byResp[4]);
#endif
    }
    return(-1);
}
/*--------------------------------------------------------------------*/
/* [֐] ޯĥؾ                                               */
/* [  ] int doReset(void)                                         */
/* [  ] none                                                      */
/* [o  ] ɾ                                                   */
/* [T  v] ޯĂؾĥĂJTAG䂩J                   */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
int doReset(void) {
    COMCELL  cc;
    BYTE     bySend[8];
    BYTE     byResp[8];

    cc.lpSend = bySend;               /* Mް߲ */
    cc.lpRecv = byResp;               /* Mް߲ */
    cc.cbRecv = sizeof(byResp);       /* Mް *//* Msv̏ꍇ  */
    bySend[0] = 'T';
    cc.cbSend = 1;
    if(ComCell(&cc,1) == ERRORNONE) {
        Sleep(500);
    }
    return(0);
}


/*--------------------------------------------------------------------*/
/* [֐] mot2dat                                                   */
/* [  ] void mot2dat(FILE *ifp,FILE *ofp)                         */
/* [  ] ifp : ̧٥߲                                      */
/*          ofp : o̧٥߲                                      */
/* [o  ] none                                                      */
/* [T  v] ̧قҰނɕϊo̧قɏ                 */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
void mot2dat(FILE *ifp,int type) {
    BYTE   code[64];
    int    len;

    printf("Writing");
    while((len = GetROMImage(type,code,ifp)) != -1) {
        if(len == -2) {
            continue;
        }
        if(tiProgram(code,len)) {
            break;
        }
        printf(".");
    }
    if(len == -1) {
        printf("OK");
    }
    printf("\n");
}
/*--------------------------------------------------------------------*/
/* [֐] decoopt                                                   */
/* [  ] int decoopt(int argc,char **argv,FILE **lppifp)           */
/* [  ] argc   : argv̗L                                     */
/*          argv   : z߲                                  */
/*          lppifp : o̧٥̍\߲                     */
/* [o  ] ߼݉͌(=0:I!=0:ُI)                  */
/* [T  v] ޥײ݂Ƃēnꂽ߼݂͂                   */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
int decoopt(int argc,char **argv,FILE **lppifp) {
    static char   buf[256];
    int    nloc;
    char  *pin    = (char *)0;
    int    rtc    = 0;

    *lppifp   = (FILE *)0;  /* stdin; */
    for(nloc = 1;nloc < argc;nloc++) {
        if((argv[nloc][0] == '-')||
           (argv[nloc][0] == '/')) {
            switch(argv[nloc][1] & 0xDF) {
                case 'P':
                    if(PortNum[0]) {
                        rtc = -1;
                        fprintf(stderr,"߰Ėdw肳Ă܂B\n");
                    } else {
                        strcpy(PortNum,&argv[nloc][2]);
                    }
                    break;
                default:
                    rtc = -1;
                    fprintf(stderr,"`ĂȂ߼݂ݒ肳Ă܂B\n");
            }
        } else if(pin != (char *)0) {
            rtc = -1;
            fprintf(stderr,"̧قdw肳Ă܂B\n");
        } else {
            pin = argv[nloc];
        }
    }
    if(pin == (char *)0) {
        rtc = -1;
        fprintf(stderr,"̧ق̎w肪܂B\n");
    } else if(rtc != -1) {
        *lppifp = fopen(pin,"rt");
        if(*lppifp == (FILE *)0) {
            rtc = -1;
            fprintf(stderr,"̧[%s]݂ł܂B\n",pin);
        }
    }
    if(rtc != -1) {
        if(!PortNum[0]) {
            strcpy(PortNum,"COM1");
        }
    }
    return(rtc);
}
/*--------------------------------------------------------------------*/
/* [֐] main                                                      */
/* [  ] int main(int argc,char **argv)                            */
/* [  ] argc   : argv̗L                                     */
/*          argv   : z߲                                  */
/* [o  ]                                                        */
/* [T  v] Ҳ݊֐                                                   */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
int main(int argc,char **argv) {
    FILE   *ifp;
    int     nid;

    PortNum[0] = '\0';
    do {
        /* ُ͈̐ */
        if(argc <= 1) {
            usage();
            break;
        }
        if(decoopt(argc,argv,&ifp) != 0) {
            break;
        }
        /* ̧قͷ̧ق */
        nid = gethextype(ifp);
        if((nid != IDHEX_INTEL)&&
           (nid != IDHEX_MOTOLORA)) {
            fprintf(stderr,"ͷȨق߂ُłB\n");
        } else {
            hComm = CreateFile(PortNum,
                               GENERIC_READ | GENERIC_WRITE,
                               0,
                               NULL,
                               OPEN_EXISTING,
                               FILE_ATTRIBUTE_NORMAL,
                               NULL);
            if(hComm == INVALID_HANDLE_VALUE) {
                fprintf(stderr, "%s could not be opened.\n", PortNum);
            } else {
                SetCommState(hComm, &dcb);
                SetCommTimeouts(hComm, &commtimeouts1);
                if((!tiGetDev())&&
                   (!tiErase())) {
                    mot2dat(ifp,nid);
                    doReset();
                }
                CloseHandle(hComm);
            }
        }
        fclose(ifp);
    } while(0);
    return(0);
}
