/*====================================================================*/
/* Copyright (c) TNK  All Rights Reserved                             */
/* [̧ٖ] tiburn.c                                                  */
/* [T  v] tbVC^                                         */
/* [Q  ]                                                           */
/* [  ] 2006/12/12       ō쐬ҁFtanaka                       */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*====================================================================*/
/*--------------------------------------------------------------------*/
/*        ݸٰ                                                     */
/*--------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>
#include "devices.h"
#include "JTAGfunc.h"            // JTAG functions
#include "LowLevelFunc.h"
#include "ftd2xx.h"

/*--------------------------------------------------------------------*/
/*        萔`                                                    */
/*--------------------------------------------------------------------*/
#define ASCIISIZE       256   /* Ǐo */
#define BLOCKSIZE       256   /* ݻ */
enum {
    TYPEUNKNOWN = -1,
    TYPEMOTOROLA1,
    TYPEMOTOROLA2,
    TYPESUM
};

#define _NEW(a)         HeapAlloc(GetProcessHeap(),HEAP_ZERO_MEMORY,a)
#define _DELETE(a)      HeapFree(GetProcessHeap(),0,(LPVOID)a)

typedef unsigned char  UBYTE;


/*--------------------------------------------------------------------*/
/*        \̒`                                                  */
/*--------------------------------------------------------------------*/


/*--------------------------------------------------------------------*/
/*        O[o                                                  */
/*--------------------------------------------------------------------*/
unsigned char  gbLatencyTimer = 0;
unsigned long  gnBaud = FT_BAUD_230400;

/*--------------------------------------------------------------------*/
/* [֐] usage                                                     */
/* [  ] void usage(void)                                          */
/* [  ] none                                                      */
/* [o  ] none                                                      */
/* [T  v] gp@WG[ɏo͂                            */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
void usage(void) {
    static char  *msg[] = {
        "usage : tiburn <infile>",
        "                  |",
        "                  +--- ϊMOŢ",
        (char *)0
    };
    int  nloc;

    for(nloc = 0;msg[nloc] != (char *)0;nloc++) {
        fprintf(stderr,"%s\n",msg[nloc]);
    }
}
/*--------------------------------------------------------------------*/
/* [֐] E޲ؕϊ                                           */
/* [  ] int WINAPI ascii2nible(BYTE uch)                          */
/* [  ] uch:ϊ                                            */
/* [o  ] ޲                                                     */
/* [T  v] w肳ꂽ޲؂ɕϊ                       */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
int WINAPI ascii2nible(BYTE uch) {
    if((uch >= '0')&&(uch <= '9')) {
        return(uch - '0');
    }
    if((uch >= 'A')&&(uch <= 'F')) {
        return((uch - 'A') + 10);
    }
    if((uch >= 'a')&&(uch <= 'f')) {
        return((uch - 'a') + 10);
    }
    return(-1);
}
/*--------------------------------------------------------------------*/
/* [֐] E޲ؕϊ                                           */
/* [  ] int WINAPI smot2bin(                                      */
/*              LPBYTE lpbyte,LPBYTE lpascii,LPINT lptype)            */
/* [  ] lpbyte :ϊ敶߲                                 */
/*          lpascii:ϊ߲                               */
/*          lptype :                                        */
/* [o  ] ϊ                                                  */
/* [T  v] w肳ꂽ޲؂ɕϊ                       */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
int WINAPI smot2bin(LPBYTE lpbyte,LPBYTE lpascii,LPINT lptype) {
    int     nible;
    BYTE    ch;
    BYTE    bybuf;
    BYTE    bysum;
    int     nrtn;

    while((ch = *lpascii++) != 'S') {
        if(ch < ' ') {
            return(0);
        }
    }
    ch = *lpascii++ - '0';
    if(ch > 9) {
        return(-1);
    }
    *lpbyte++ = ch;
    for(bysum = 0,nrtn = 0;*lpascii >= ' ';nrtn++) {
        nible = ascii2nible(*lpascii++);
        if(nible < 0) {
            return(-1);
        }
        bybuf = (BYTE)(nible << 4);
        nible = ascii2nible(*lpascii++);
        if(nible < 0) {
            return(-1);
        }
        bybuf    |= (BYTE)nible;
        *lpbyte++ = bybuf;
        bysum    += bybuf;
    }
    if(*lptype == TYPEUNKNOWN) {
        if(bysum == 0xFF) {
            *lptype = TYPEMOTOROLA1;
        } else if(bysum == 0x00) {
            *lptype = TYPEMOTOROLA2;
        }
    } else {
        if(*lptype == TYPEMOTOROLA1) {
            if(bysum != 0xFF) {
                nrtn = -1;
            }
        } else if(*lptype == TYPEMOTOROLA2) {
            if(bysum != 0x00) {
                nrtn = -1;
            }
        } else {
            nrtn = -1;
        }
        if(nrtn < 0) {
            printf("тɈُ킪܂B\n");
        }
    }
    return(nrtn);
}
/*--------------------------------------------------------------------*/
/* [֐] MOŢٕϊ                                               */
/* [  ] DWORD WINAPI GetMotDat(                                   */
/*              FILE *ifp,LPBYTE lpImg,LPBYTE lpMap,int nShift,       */
/*              LPINT lptype)                                         */
/* [  ] ifp   :̧فE߲                                        */
/*          lpImg :ϊފi[߲                                */
/*          lpMap :ϊޗL\ۑ߲                        */
/*          nShift:ۯE                                        */
/*          lptype:                                         */
/* [o  ] ϊ                                                  */
/* [T  v] w肳ꂽ̧ق޲؂ɕϊۯ̗L/Ă */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
DWORD WINAPI GetMotDat(
FILE *ifp,
LPBYTE lpImg,
LPBYTE lpMap,
int nShift,
LPINT lptype) {
    BYTE   szBuf[ASCIISIZE];
    BYTE   byCnv[128];
    BYTE  *chp;
    int    type;
    int    ncnt;
    DWORD  addr;
    int    nlno;
    DWORD  addrhold = 0;

    for(nlno = 1;fgets(szBuf,sizeof(szBuf),ifp);nlno++) {
        if(szBuf[0] == '\0') {
            break;
        }
        ncnt = smot2bin(byCnv,szBuf,lptype);
        if((ncnt < 5)&&(ncnt != 0)) {
            sprintf(szBuf,"line[%d] record error.\n",nlno);
//            MessageBox(NULL,szBuf,gszAppName,MB_OK);
        } else {
            chp  = byCnv;
            type = *chp++;
            ncnt = *chp++;
            addr = 0;
            switch(type) {
                case 3:
                    addr |= (DWORD)*chp++ * 0x1000000;
                    ncnt -= 1;
                case 2:
                    addr  = (DWORD)*chp++ * 0x10000;
                    ncnt -= 1;
                case 1:
                    addr |= (DWORD)*chp++ * 0x100;
                    addr |= (DWORD)*chp++;
                    ncnt -= 2 + 1; //+sum
                    if(addrhold < (addr + ncnt - 1)) {
                        addrhold = (addr + ncnt - 1);
                    }
                    if(lpImg) {
                        CopyMemory(&lpImg[addr],chp,ncnt);
                        lpMap[addr >> nShift] = TRUE;
                        lpMap[(addr + ncnt - 1) >> nShift] = TRUE;
                    }
            }
        }
    }
    fseek(ifp,0L,SEEK_SET);
    return(addrhold);
}
/*--------------------------------------------------------------------*/
/* [֐] ̧٥ߎ擾                                             */
/* [  ] int WINAPI GetHexType(FILE *ifp,LPINT lpi)                */
/* [  ] ifp:̧٥߲                                            */
/*          lpi:sĥ߲                                        */
/* [o  ] 茋                                                  */
/* [T  v] w肳ꂽ̧ق߂擾                            */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
int WINAPI GetHexType(FILE *ifp,LPINT lpi) {
    CHAR  szBuf[ASCIISIZE];
    BYTE  byCnv[128];
    int   nrtc = TYPEUNKNOWN;

    for(*lpi = 0;fgets(szBuf,sizeof(szBuf),ifp);(*lpi)++) {
        if(szBuf[0] == 'S') {
            if(nrtc == TYPEUNKNOWN) {
                smot2bin(byCnv,szBuf,&nrtc);
            } else if((nrtc != TYPEMOTOROLA1)&&
                      (nrtc != TYPEMOTOROLA2)) {
                nrtc = TYPEUNKNOWN;
                break;
            }
        } else if(szBuf[0] == '\0') {       //I
            break;
        } else if(szBuf[0] != '\n') {
            nrtc = TYPEUNKNOWN;
            break;
        }
    }
    fseek(ifp,0L,SEEK_SET);
    return(nrtc);
}
/*--------------------------------------------------------------------*/
/* [֐] ׯײ                                                 */
/* [  ] BOOL WINAPI SendMot(FILE *ifp)                            */
/* [  ] ifp:̧٥߲                                            */
/* [o  ] ݌                                              */
/* [T  v] ̧قϊׯ֏                             */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
BOOL WINAPI SendMot(FILE *ifp) {
    DWORD    cb;       // size of file and count of bytes read 
    int      nType;
    LPBYTE   lpImg;
    LPBYTE   lpMap;
    int      nShift;
    int      nLoc;
    INT      nLine;
    BOOL     bRtc = FALSE;

    do {
        nType = GetHexType(ifp,&nLine);
        if(nType == TYPEUNKNOWN) {
            printf("w肳ꂽ̧ق۰S̫ϯĂł܂B\n");
            break;
        }
        do {
            cb    = GetMotDat(ifp,(LPBYTE)NULL,(LPBYTE)NULL,0,&nType);
            lpImg = _NEW(cb + BLOCKSIZE - 1);
            lpMap = _NEW((cb / BLOCKSIZE) + ((cb % BLOCKSIZE)?  1 : 0));
            if((!lpImg)||(!lpMap)) {
                printf("Ɨp؂mۂł܂B\n");
                break;
            }
            FillMemory(lpImg,cb + BLOCKSIZE - 1,0xFF);
            FillMemory(lpMap,(cb / BLOCKSIZE) + ((cb % BLOCKSIZE)?  1 : 0),0x00);
            for(nShift = 0,nLoc = 1;
                (nLoc < 0x10000)&&(BLOCKSIZE > (DWORD)nLoc);
                nLoc <<= 1,nShift++);
            GetMotDat(ifp,lpImg,lpMap,nShift,&nType);
            printf("write ");
            // Set the range and increment of the progress bar. 
            for(nLoc = 0;cb != 0;nLoc++) {
                cb -= (cb >= BLOCKSIZE)?  BLOCKSIZE : cb;
                if(lpMap[nLoc]) {
                    WriteFLASH(nLoc << nShift,BLOCKSIZE,(word *)&lpImg[nLoc << nShift]);
                    if(!VerifyMem(nLoc << nShift,BLOCKSIZE,(word *)&lpImg[nLoc << nShift])) {
                        break;
                    }
                    printf(".");
                }
            }
            if(cb) {
                printf(" ׯ؂݂̏Ɏs܂B");
            } else {
                printf(" done.");
            }
            printf("\n");
            bRtc = TRUE;
        } while(0);
        if(lpImg) {
            _DELETE(lpImg);
        }
        if(lpMap) {
            _DELETE(lpMap);
        }
    } while(0);

    return(bRtc);
}
/*--------------------------------------------------------------------*/
/* [֐] decoopt                                                   */
/* [  ] int decoopt(int argc,char **argv,FILE **lppifp)           */
/* [  ] argc   : argv̗L                                     */
/*          argv   : z߲                                  */
/*          lppifp : o̧٥̍\߲                     */
/* [o  ] ߼݉͌(=0:I!=0:ُI)                  */
/* [T  v] ޥײ݂Ƃēnꂽ߼݂͂                   */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
int decoopt(int argc,char **argv,FILE **lppifp) {
    static char   buf[256];
    int    nloc;
    char  *pin    = (char *)0;
    int    rtc    = 0;

    *lppifp   = (FILE *)0;  /* stdin; */
    for(nloc = 1;nloc < argc;nloc++) {
        if((argv[nloc][0] == '-')||
           (argv[nloc][0] == '/')) {
            switch(argv[nloc][1] & 0xDF) {
                case 'B':
                    gnBaud = (unsigned long)atoi(&argv[nloc][2]);
                    break;
                case 'T':
                    gbLatencyTimer = (unsigned char)atoi(&argv[nloc][2]);
                    break;
                default:
                    rtc = -1;
                    fprintf(stderr,"`ĂȂ߼݂ݒ肳Ă܂B\n");
            }
        } else if(pin != (char *)0) {
            rtc = -1;
            fprintf(stderr,"̧قdw肳Ă܂B\n");
        } else {
            pin = argv[nloc];
        }
    }
    if(pin == (char *)0) {
        rtc = -1;
        fprintf(stderr,"̧ق̎w肪܂B\n");
    } else if(rtc != -1) {
        *lppifp = fopen(pin,"rt");
        if(*lppifp == (FILE *)0) {
            rtc = -1;
            fprintf(stderr,"̧[%s]݂ł܂B\n",pin);
        }
    }
    return(rtc);
}
/*--------------------------------------------------------------------*/
/* [֐] main                                                      */
/* [  ] int main(int argc,char **argv)                            */
/* [  ] argc   : argv̗L                                     */
/*          argv   : z߲                                  */
/* [o  ]                                                        */
/* [T  v] Ҳ݊֐                                                   */
/* [Q  ]                                                           */
/* [  ]                                                           */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* [  ]  e                                    DateFcoding     */
/*--------------------------------------------------------------------*/
int main(int argc,char **argv) {
    FILE   *ifp;

    do {
        /* ُ͈̐ */
        if(argc <= 1) {
            usage();
            break;
        }
        if(decoopt(argc,argv,&ifp) != 0) {
            break;
        }
        if(InitTarget()) {
            do {
                printf("initialize OK\n");
                printf("Get Device\n");
                if(!GetDevice()) {                    // Set DEVICE index, stop
                    ShowStatus(STATUS_ERROR,1);        // here if invalid JTAG ID or
                    break;
                }
                printf("Erase Start\n");
                EraseFLASH(ERASE_MASS, 0xFE00);       // Mass-Erase Flash (all types)
                printf("Erase Check High address\n");
                if(!EraseCheck(0x8000,0x4000)) {     // Check main memory erasure (Fxx2..9)
                    ShowStatus(STATUS_ERROR,3);
                    break;
                }
                printf("Erase Check low address\n");
                if(!EraseCheck(0x1000,0x0080)) {     // Check main memory erasure (Fxx2..9)
                    ShowStatus(STATUS_ERROR,3);
                    break;
                }
                SendMot(ifp);
            } while(0);
            ReleaseDevice(V_RESET);               // Perform Reset, release CPU from JTAG control
            Sleep(1000);
            ReleaseTarget();
        }
        fclose(ifp);
    } while(0);
    return(0);
}
